DECLARE SUB graphicput (grpt$, x, y, m$)
0 :
REM'OverWorld - 03-04-1996 - {Aquarius Games}
REM'Updated: 08/31/1997 - Xen ( Tim Keal )
REM'Updated: 12/17/1998 - jargon ( Tim Keal )
REM'email: jargon@juno.com
REM'Updated: 01-12-1999 - jargon
REM'bugfixes are represented as 8 digit date code as month## day## year####
REM'bugfixes can now be searched for by looking for '[!]'
REM'--
REM'bugfix: 01121999 - jargon
REM'allows map to load and save new position correctly
REM'corrected clipboard allocation
REM'--
COMMON SHARED sz
'[!]bugfix 01121999 - the line below has +11 instead of +8 to fix clipboard allocation
DIM SHARED scn(24 * 24 + 11): REM'clipboard
REM'DIM SHARED vm$(gz): REM '''graphics ID
DIM SHARED gr(-3 TO 3, -3 TO 3): REM '''terrein view map
DIM SHARED cr(-3 TO 3, -3 TO 3): REM '''object view map
DIM SHARED cs(-3 TO 3, -3 TO 3): REM '''object view map
DIM SHARED lc(-3 TO 3, -3 TO 3): REM '''modified creation
DIM SHARED d(0 TO 4, 0 TO 1)
DIM SHARED clr(0 TO 15, 1 TO 3)
DIM SHARED pal(0 TO 255, 1 TO 3)

pal(0, 1) = 0: pal(0, 2) = 0: pal(0, 3) = 0
pal(1, 1) = 0: pal(1, 2) = 0: pal(1, 3) = 31
pal(2, 1) = 0: pal(2, 2) = 31: pal(2, 3) = 0
pal(3, 1) = 0: pal(3, 2) = 15: pal(3, 3) = 15
pal(4, 1) = 31: pal(4, 2) = 0: pal(4, 3) = 0
pal(5, 1) = 15: pal(5, 2) = 0: pal(5, 3) = 15
pal(6, 1) = 15: pal(6, 2) = 15: pal(6, 3) = 0
pal(7, 1) = 47: pal(7, 2) = 47: pal(7, 3) = 47
pal(8, 1) = 15: pal(8, 2) = 15: pal(8, 3) = 15
pal(9, 1) = 0: pal(9, 2) = 0: pal(9, 3) = 63
pal(10, 1) = 0: pal(10, 2) = 63: pal(10, 3) = 0
pal(11, 1) = 0: pal(11, 2) = 63: pal(11, 3) = 63
pal(12, 1) = 63: pal(12, 2) = 0: pal(12, 3) = 0
pal(13, 1) = 63: pal(13, 2) = 0: pal(13, 3) = 63
pal(14, 1) = 63: pal(14, 2) = 63: pal(14, 3) = 0
pal(15, 1) = 63: pal(15, 2) = 63: pal(15, 3) = 63

d(0, 0) = 0: d(0, 1) = 0
d(1, 0) = 0: d(1, 1) = -1
d(2, 0) = 1: d(2, 1) = 0
d(3, 0) = 0: d(3, 1) = 1
d(4, 0) = -1: d(4, 1) = 0

SCRN = 13
SCREEN SCRN
COLOR 15
CLS

CLOSE 5
OPEN "pzlm_w05.pal" FOR INPUT AS 5
FOR t = 175 TO 255
 INPUT #5, red, green, blue
 PALETTE t, red + green * 256 + blue * 256 ^ 2
NEXT t
CLOSE 5
FOR t = 1 TO 16
 red = 0
 green = INT(63 * .5 * t / 16 + 15)
 blue = INT(63 * t / 16)
 PALETTE t + 174 + 16 * 3, red + green * 256 + blue * 256 ^ 2
NEXT t

RANDOMIZE TIMER
RESTORE
WIDTH 40, 25

clr(0, 1) = 0: clr(0, 2) = 0: clr(0, 3) = 0
clr(1, 1) = 2: clr(1, 2) = 0: clr(1, 3) = 0
clr(2, 1) = 0: clr(2, 2) = 2: clr(2, 3) = 0
clr(3, 1) = 2: clr(3, 2) = 2: clr(3, 3) = 0
clr(4, 1) = 0: clr(4, 2) = 0: clr(4, 3) = 2
clr(5, 1) = 2: clr(5, 2) = 0: clr(5, 3) = 2
clr(6, 1) = 0: clr(6, 2) = 2: clr(6, 3) = 2
clr(7, 1) = 2: clr(7, 2) = 2: clr(7, 3) = 2
clr(8, 1) = 1: clr(8, 2) = 1: clr(8, 3) = 1
clr(9, 1) = 3: clr(9, 2) = 0: clr(9, 3) = 0
clr(10, 1) = 0: clr(10, 2) = 3: clr(10, 3) = 0
clr(11, 1) = 3: clr(11, 2) = 3: clr(11, 3) = 0
clr(12, 1) = 0: clr(12, 2) = 0: clr(12, 3) = 3
clr(13, 1) = 3: clr(13, 2) = 0: clr(13, 3) = 3
clr(14, 1) = 0: clr(14, 2) = 3: clr(14, 3) = 3
clr(15, 1) = 3: clr(15, 2) = 3: clr(15, 3) = 3

REM'FOR clror = 0 TO 15
REM' PALETTE clror, clr(clror, 1) + clr(clror, 2) * 4 + clr(clror, 3) * 4 ^ 2
REM'NEXT clror

timm = 0
timh = 0
timd = 0
pal = 1

100 BR = TIMER: bt = .2: gc = 1: sb = TIMER: sa = .1: GE = 1
105 vx2 = 1: vy2 = 1: d1 = 1
106 x(1) = 0: y(1) = -1: m(1) = 3
107 x(2) = 1: y(2) = 0: m(2) = 0
108 x(3) = 0: y(3) = 1: m(3) = 1
109 x(4) = -1: y(4) = 0: m(4) = 2
115 a$(0) = CHR$(4): a$(1) = CHR$(24): a$(2) = CHR$(26): a$(3) = CHR$(25): a$(4) = CHR$(27)
120 's=1:o=4:i=1
125 vx1 = 9: vy1 = 15: d1 = 1: vx2 = vx1: vy2 = vy1: d2 = d1: ''''chtr mem
128 nm$ = "Pndx"

130 :
'''''Area mem load
''''LINE (0, 0)-(319, 199), 0, BF
CLOSE
OPEN nm$ + "_001.sav" FOR INPUT AS 1
INPUT #1, p1$, vx2, vy2, d1, vx2, vy2, nm$, c1$, c2$, c3$, s, o, i, p: CLOSE 1

OPEN p1$ + ".txt" FOR INPUT AS 1
INPUT #1, P2$, p3$, xx, yy, ck$(1), ck$(2), ck$(3), ck$(4), rd$, bm$
rd$ = " " + rd$ + " "
CLOSE 2
'OPEN bm$ FOR INPUT AS 2

140 :
sz = 24: gz = 256: '''map mem
bm$ = p1$ + ".bgm": '''music
gm$ = "pzlm_w05.mem": DIM vm$(gz): DIM vm(gz): tx = 1: ty = 1: '''terrein graphics ID
om$ = p1$ + ".mom": DIM obj$(0 TO 255, 1 TO 4): DIM obj(0 TO 255): DIM objs(0 TO 255): '''object graphics ID/size/speed

'SHELL "copy pzlm_w06.map pzlm_gr1.tmp"
'SHELL "copy pzlm_w06.map pzlm_gr2.tmp"
'SHELL "copy pzlm_w06.map pzlm_gr3.tmp"

mg$ = "pzlm_gr1.tmp": REM'DIM gr(xx + 1, yy + 1): '''terrein map
mgb$ = "pzlm_gr2.tmp": '''object map
mgc$ = "pzlm_gr3.tmp": '''low object map
sv$ = p1$ + ".sav"
bt$ = p1$ + ".btl"
c1$ = "001"
c2$ = "002"
c3$ = "003"

''''LINE (0, 0)-(319, 199), 0, BF
CLOSE 1
280 :
'''''terrein Graphics Load
t = 8: tt = 8
CLOSE 1
OPEN gm$ FOR INPUT AS 1
FOR z = 1 TO gz
  INPUT #1, vm$(z)
  FOR zz = 1 TO 4
    INPUT #1, r
    IF r = zz THEN ck$(zz) = ck$(zz) + STR$(z)
  NEXT zz
  INPUT #1, vm(z)
NEXT z
FOR zz = 1 TO 4
  ck$(zz) = ck$(zz) + " "
NEXT zz
CLOSE 1
'''''object Graphics Load
OPEN om$ FOR INPUT AS 1
FOR z = 1 TO 255
  INPUT #1, obj$(z, 1), obj$(z, 2), obj$(z, 3), obj$(z, 4), obj(z), objs(z)
NEXT z
CLOSE 1
'gosub 50000

300 :
'''''Map Load & View Screen
LINE (0, 0)-(319, 199), 0, BF
'[!]bugfix 01121999'vx2 = 9
'[!]bugfix 01121999'vy2 = 45
310 :
CLOSE 1
OPEN mg$ FOR BINARY AS #1
OPEN mgb$ FOR BINARY AS #2
OPEN mgc$ FOR BINARY AS #3
OPEN "pzlm_gr4.tmp" FOR BINARY AS #4
OPEN "pzlm_gr5.tmp" FOR BINARY AS #5
xx$ = SPACE$(2)
yy$ = SPACE$(2)
GET #1, 1, xx$
GET #1, 3, yy$
wx = ASC(MID$(xx$, 1, 1)) * 256 + ASC(MID$(xx$, 2, 1))
wy = ASC(MID$(yy$, 1, 1)) * 256 + ASC(MID$(yy$, 2, 1))
'[!]bugfix 01121999'vx2 = INT(wx / 2)
'[!]bugfix 01121999'vy2 = INT(wy / 2)
IF vx2 - 3 < 1 THEN vx2 = 4
IF vy2 - 3 < 1 THEN vy2 = 4
IF vx2 + 3 > wx THEN vx2 = wx - 4
IF vy2 + 3 > wy THEN vy2 = wy - 4
xleft = -3: 'IF vx2 + xleft < 0 THEN xleft = vx2 - 0
xright = 3: 'IF vx2 + xright > wx THEN xright = vx2 - wx
yleft = -3: 'IF vy2 + yleft < 0 THEN yleft = vy2 - 0
yright = 3: 'IF vy2 + yright > yx THEN yright = vy2 - wy
FOR y = -3 TO 3
  FOR x = -3 TO 3
    gr(x, y) = 0
  NEXT x
NEXT y
LINE (0, 0)-(5 * sz - 1, 5 * sz - 1), 0, BF
FOR y = yleft TO yright
  FOR x = xleft TO xright
    rr$ = SPACE$(1)
    GET #1, (vx2 + x + (vy2 + y) * wx + 4), rr$
    z = ASC(rr$)
    gr(x, y) = z
    t = x + 3
    tt = y + 3
    'graphicput vm$(z), (t + 0 - 1) * sz+8, (tt + 0 - 1) * sz+8
  NEXT x
NEXT y

vx1 = vx2
vy1 = vy2
'PCOPY 1, 0
'PCOPY 1, 2
'PCOPY 1, 3
''''LINE (0, 0)-(319, 199), 11, B
GOSUB 23000
'WHILE INKEY$ = "": WEND

500 :
beast = TIMER

GOTO 20500

900 :
'VisCRSR ANIMATE
pc = POINT(x, y): pp = POINT(xx, yy)
cc = 15 - POINT(x, y)
IF px > 631 THEN px = 631
IF py > 341 THEN py = 341
IF TIMER - bt > BR THEN CB = (CB MOD 4) + 1: bt = TIMER
IF (CB = 1 OR CB = 3) THEN graphicput (nm$ + "_" + c1$ + ".08x"), px, py, ""
IF CB = 2 THEN graphicput (nm$ + "_" + c2$ + ".08x"), px, py, ""
IF CB = 4 THEN graphicput (nm$ + "_" + c3$ + ".08x"), px, py, ""
RETURN

1000 :
'''''Area mem Save
CLOSE 1
OPEN nm$ + "_001.sav" FOR OUTPUT AS 1
PRINT #1, p1$
PRINT #1, vx2: '+vx2-1
PRINT #1, vy2: '+vy2-1
PRINT #1, d1
PRINT #1, vx2
PRINT #1, vy2
PRINT #1, nm$
PRINT #1, c1$
PRINT #1, c2$
PRINT #1, c3$
PRINT #1, s
PRINT #1, o
PRINT #1, i
PRINT #1, p
CLOSE 1
RETURN

20500 ''main
20502 RANDOMIZE TIMER
20505 c$ = INKEY$: cc$ = " " + c$ + " ": vx1 = vx2: vy1 = vy2: d1 = d2: g1 = g2
20506 'IF TIMER - beast > 30 AND INT(RND(1) * 50) = 1 THEN pcopy 2,3:chain bt$,15,all
20507 'IF c$ = "W" OR c$ = "w" THEN pcopy 2,3:chain bt$,15,all
IF c$ = "i" OR c$ = "I" THEN i = 1 - i
REM'''IF c$ = "R" OR c$ = "r" THEN GOSUB 1000
'''IF c$ = "s" OR c$ = "S" THEN s = 1 - s
IF c$ = "o" OR c$ = "O" THEN o = (o MOD 4) + 1
IF vx2 > wx THEN
  vx2 = wx
ELSE
  IF vx2 < 1 THEN
    vx2 = 1
  END IF
END IF
IF vy2 > wy THEN
  vy2 = wy
ELSE
  IF vy2 < 1 THEN
    vy2 = 1
  END IF
END IF
IF vx2 + d(d, 0) >= 0 AND vx2 + d(d, 0) <= wx AND vy2 + d(d, 1) >= 0 AND vy2 + d(d, 1) <= wy THEN

IF 1 = 0 THEN
REM'the following 4 blocked IFs allow terrein map alteration
  IF c$ = "+" AND gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) < 64 THEN
    rr$ = CHR$(gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) + 1)
    PUT #1, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "-" AND gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) > 1 THEN
    rr$ = CHR$(gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) - 1)
    PUT #1, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "f" AND gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) < 64 - 16 THEN
    rr$ = CHR$(gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) + 16)
    PUT #1, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "F" AND gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) > 1 + 16 THEN
    rr$ = CHR$(gr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) - 16)
    PUT #1, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
END IF

IF 1 = 0 THEN
REM'the following 3 blocked IFs allow object map alteration
  IF c$ = CHR$(8) AND cr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) > 0 THEN
    rr$ = CHR$(0)
    PUT #2, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "*" AND cr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) < 255 THEN
    rr$ = CHR$(cr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) + 1)
    PUT #2, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "/" AND cr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) > 0 THEN
    rr$ = CHR$(cr(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) - 1)
    PUT #2, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
END IF

IF 1 = 0 THEN
REM'the following 3 blocked IFs allow low object map alteration
  IF c$ = "\" AND cs(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) > 0 THEN
    rr$ = CHR$(0)
    PUT #3, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "]" AND cs(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) < 255 THEN
    rr$ = CHR$(cs(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) + 1)
    PUT #3, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
  IF c$ = "[" AND cs(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) > 0 THEN
    rr$ = CHR$(cs(vx2 - vx1 + d(d2, 0), vx2 - vx1 + d(d2, 1)) - 1)
    PUT #3, (vx2 + d(d2, 0) + (vy2 + d(d2, 1)) * wx + 4), rr$
  END IF
END IF

  IF c$ = "h" THEN
   vx2 = vx2 + 1
  END IF
  IF c$ = "g" THEN
   vx2 = vx2 - 1
  END IF
  IF c$ = "b" THEN
   vy2 = vy2 + 1
  END IF
  IF c$ = "y" THEN
   vy2 = vy2 - 1
  END IF
END IF
IF INSTR(" Y y 8 ", cc$) > 0 THEN d2 = 1
IF INSTR(" H h 6 ", cc$) > 0 THEN d2 = 2
IF INSTR(" B b 2 ", cc$) > 0 THEN d2 = 3
IF INSTR(" G g 4 ", cc$) > 0 THEN d2 = 4
IF INSTR(" 5 ", cc$) > 0 THEN
  d2 = 0
  'vx2 = vx1 + d(d2, 0)
  'vy2 = vy1 + d(d2, 1)
END IF
IF INSTR(" 7 ", cc$) > 0 THEN d2 = ((d2 + 2) MOD 4) + 1
IF INSTR(" 9 ", cc$) > 0 THEN d2 = (d2 MOD 4) + 1
IF c$ = "." THEN p = 1 - p
g2 = gr(vx2 - vx1, vy2 - vy1)
IF p <> 1 OR INSTR(1, rd$, g2$) = 0 OR GE < 4 THEN 20550

g2 = 0
f2 = 0
g2$ = "_"
WHILE INSTR(1, rd$, g2$) = 0 AND f2 < 5
  f2 = f2 + 1
  d2 = ((d1 + m(f2) - 1) MOD 4) + 1
  vx2 = vx1 + d(d2, 0)
  vy2 = vy1 + d(d2, 1)
  IF vx2 > wx THEN
    vx2 = wx
  ELSE
    IF vx2 < 1 THEN
      vx2 = 1
    END IF
  END IF
  IF vy2 > wy THEN
    vy2 = wy
  ELSE
    IF vy2 < 1 THEN
      vy2 = 1
    END IF
  END IF
  g2 = gr(vx2 - vx1, vy2 - vy1)
  g2$ = STR$(g2) + " "
WEND

20550 :
IF vx2 <> vx1 OR vy2 <> vy1 THEN GE = 1
IF f2 = 5 THEN
  vx2 = vx1
  vy2 = vy1
  d2 = d1
END IF
IF vx2 > wx THEN
  vx2 = wx
ELSE
  IF vx2 < 1 THEN
    xv2 = 1
  END IF
END IF
IF vy2 > wy THEN
  vy2 = wy
ELSE
  IF vy2 < 1 THEN
    vy2 = 1
  END IF
END IF
g2 = gr(vx2 - vx1, vy2 - vy1)
g2$ = STR$(g2) + " "
REM'the following two lines limit movement
IF INSTR(1, ck$(d2), g2$) > 0 THEN vx2 = vx1: vy2 = vy1: g2 = g1
IF cr(d(d2, 0), d(d2, 1)) <> 0 THEN vx2 = vx1: vy2 = vy1: g2 = g1

IF vx2 > wx THEN vx2 = wx ELSE IF vx2 < 1 THEN vx2 = 1
IF vy2 > wy THEN vy2 = wy ELSE IF vy2 < 1 THEN vy2 = 1

'''(vx1/vx2,vy1/vy2 final)

FOR y = -3 TO 3
 FOR x = -3 TO 3
  lc(x, y) = 0
 NEXT x
NEXT y

IF gc = 4 THEN
 FOR y = -3 TO 3
  FOR x = -3 TO 3
   IF cr(x, y) > 1 AND lc(x, y) = 0 THEN
    lc(x, y) = 1
    actionr$ = ""
    dirr = INT(RND(1) * 4) + 1
    IF x + d(dirr, 0) > -4 AND x + d(dirr, 0) < 4 AND y + d(dirr, 1) > -4 AND y + d(dirr, 1) < 4 THEN
     IF cr(x + d(dirr, 0), y + d(dirr, 1)) = 0 THEN
      actionr$ = "move"
     ELSE
      actionr$ = "attack"
     END IF
   
     IF actionr$ = "move" THEN
      REM'the following two lines limit movement
      IF INSTR(1, ck$(dirr), (STR$(gr(x + d(dirr, 0), y + d(dirr, 1))) + " ")) > 0 THEN actionr$ = ""
      IF cr(d(dirr, 0), d(dirr, 1)) <> 0 THEN actionr$ = ""
     END IF

     IF actionr$ = "move" THEN

      SWAP lc(x, y), lc(x + d(dirr, 0), y + d(dirr, 1))
     
      SWAP cr(x, y), cr(x + d(dirr, 0), y + d(dirr, 1))
      rr$ = CHR$(cr(x + d(dirr, 0), y + d(dirr, 1)))
      PUT #2, (vx1 + x + d(dirr, 0) + (vy1 + y + d(dirr, 1)) * wx + 4), rr$
      rr$ = CHR$(cr(x, y))
      PUT #2, (vx1 + x + (vy1 + y) * wx + 4), rr$
     
      SWAP cs(x, y), cs(x + d(dirr, 0), y + d(dirr, 1))
      rr$ = CHR$(cs(x + d(dirr, 0), y + d(dirr, 1)))
      PUT #3, (vx1 + x + d(dirr, 0) + (vy1 + y + d(dirr, 1)) * wx + 4), rr$
      rr$ = CHR$(cs(x, y))
      PUT #3, (vx1 + x + (vy1 + y) * wx + 4), rr$
    
     END IF
    
     IF actionr$ = "attack" THEN
     END IF

    END IF
   END IF
  NEXT x
 NEXT y
END IF

'timers

IF TIMER - BR > bt THEN BR = TIMER: gc = (gc MOD 4) + 1
IF TIMER - sb > sa THEN sb = TIMER: GE = (GE MOD 4) + 1
IF gc = 4 THEN timm = timm + 1

IF (vx1 <> vx2 OR vy1 <> vy2) THEN
 timm = timm + INT(RND(1) * 15) + 15 + 1
END IF

IF timd = 0 THEN timd = 1
WHILE timm >= 60
 timm = timm - 60
 timh = timh + 1
WEND
WHILE timh >= 24
 timh = timh - 24
 timd = timd + 1
WEND

IF (vx1 <> vx2 OR vy1 <> vy2) THEN
 SWAP cr(0, 0), cr(d(d2, 0), d(d2, 1))
 rr$ = CHR$(cr(d(d2, 0), d(d2, 1)))
 PUT #2, (vx2 + vy2 * wx + 4), rr$
 rr$ = CHR$(cr(0, 0))
 PUT #2, (vx1 + vy1 * wx + 4), rr$
END IF

IF (vx1 <> vx2 OR vy1 <> vy2) THEN
 SWAP cs(0, 0), cs(d(d2, 0), d(d2, 1))
 rr$ = CHR$(cs(d(d2, 0), d(d2, 1)))
 PUT #3, (vx2 + vy2 * wx + 4), rr$
 rr$ = CHR$(cs(0, 0))
 PUT #3, (vx1 + vy1 * wx + 4), rr$
END IF

'set old values at new
vx1 = vx2
vy1 = vy2
d1 = d2
g1 = g2
IF c$ = CHR$(27) THEN SCREEN 0, 0, 0, 0: WIDTH 80: COLOR 15, 1, 1: VIEW PRINT 1 TO 25: CLS : GOSUB 1000: END
'PCOPY 2, 1

'''the following line calls the graphics viewscreen
GOSUB 22000

20615 IF c$ = "p" OR c$ = "P" THEN WHILE INKEY$ = "": WEND
20616 'IF o = 2 THEN 20650
20617 'IF o = 1 OR o = 3 THEN oo = 1 - oo: IF oo = 1 THEN 20650
20621 'LINE (0 - 8, 0 - 8)-(327, (vy2 - 4) * 8 - 4), 3, BF: '1
20622 'LINE (327, 0 - 8)-((vx2 + 4) * 8 + 4, 207), 3, BF: '2
20623 'LINE (0 - 8, 207)-(327, (vy2 + 3) * 8 + 4), 3, BF: '3
20624 'LINE (0 - 8, 0 - 8)-((vx2 - 5) * 8 - 4, 207), 3, BF: '4
20625 'LINE ((vx2 - 5) * 8 - 4, (vy2 - 4) * 8 - 4)-((vx2 + 4) * 8 + 4, (vy2 + 3) * 8 + 4), 11, B

20650 IF i = 0 THEN 20730
20651 ''''LINE ((73 - 1) * 8, (1 - 1) * 8)-((80 * 8) - 1, (25 * 8) - 1), 0, BF
20652 COLOR 5: LOCATE 2, 33: IF gc = 1 OR gc = 3 THEN COLOR 13: PRINT "PuZzLuM";
20653 IF gc = 2 OR gc = 4 THEN COLOR 5: PRINT "pUzZlUm"; : COLOR 15
20654 COLOR 11: LOCATE 3, 33: PRINT P2$; : COLOR 15
20655 COLOR 15: LOCATE 5, 33: PRINT nm$;
20656 COLOR 15: LOCATE 6, 33: PRINT "Aim:"; : COLOR 9: IF p = 1 THEN COLOR 1
20658 PRINT a$(d2); : COLOR 15
20659 COLOR 15: LOCATE 7, 33: PRINT "Arm:"; : COLOR 8: IF GE >= 4 THEN COLOR 15
20660 PRINT GE; : COLOR 15

LOCATE 9, 33
timd$ = RIGHT$(STR$(1000 + (timd MOD 365) + 1), 3)
PRINT "Day " + timd$;
LOCATE 10, 33
timh$ = RIGHT$(STR$(1000 + (timh MOD 12) + 1), 2)
timm$ = RIGHT$(STR$(1000 + (timm MOD 60)), 2)
PRINT timh$ + ":" + timm$;
IF timh < 12 THEN PRINT "am"
IF timh >= 12 THEN PRINT "pm"

'pal(1, 1) = INT(7 + 15 * ABS(COS(TIMER / 10 + .2)))
'pal(1, 3) = INT(15 + 31 * ABS(COS(TIMER / 10)))
'pal(9, 1) = INT(7 + 7 * ABS(COS(TIMER / 10 + .2)))
'pal(9, 3) = INT(31 + 15 * ABS(COS(TIMER / 10 + .3)))
'dark = (12 * 60 - ABS(timh * 60 + timm - 12 * 60)) / (12 * 60)
'IF dark < 0 THEN dark = 0
'IF dark > 1 THEN dark = 1
'pal = (pal + 1) MOD 16
'PALETTE pal, INT(pal(pal, 1) * dark) + INT(pal(pal, 2) * dark) * 256 + INT(pal(pal, 3) * dark) * 256 ^ 2

''day palette
'IF (timh >= 5 AND timh < 21) AND pal = 0 THEN
' pal = 1
'  PALETTE
'END IF
''night palette
'IF (timh < 5 OR timh >= 21) AND pal = 1 THEN
' pal = 0
' IF 1 = 0 THEN
'  FOR ttt = 0 TO 15
'   PALETTE 0, INT(pal(ttt, 1) * dark) + INT(pal(ttt, 2) * dark) * 256 + INT(pal(ttt, 3) * dark) * 256 ^ 2
'  NEXT ttt
' END IF
'END IF

'palette rotation for 239 - 242
t# = (TIMER * 4) MOD 4
FOR tt# = 0 TO 3
 PALETTE (239 + (tt# + t# + 0) MOD 4), (8 * tt#) + (16 * tt#) * 256 + 63 * 256 ^ 2
NEXT tt#

LOCATE 12, 33
PRINT "gr:"; RIGHT$(STR$(1000 + gr(d(d2, 0), d(d2, 1))), 3);
LOCATE 13, 33
PRINT "cr:"; RIGHT$(STR$(1000 + cr(d(d2, 0), d(d2, 1))), 3);
LOCATE 14, 33
PRINT "cs:"; RIGHT$(STR$(1000 + cs(d(d2, 0), d(d2, 1))), 3);

LOCATE 16, 33
PRINT "x:"; vx2;
LOCATE 17, 33
PRINT "y:"; vy2;

20720 'LINE((1-1)*8,(1-1)*8)-((wx*8)-1,(wy*8)-1),11,B,22035
20730 'PCOPY 1, 0
20735 '''IF EOF(2) THEN CLOSE 2: OPEN bm$ FOR INPUT AS 2
20736 '''IF s = 1 THEN INPUT #2, n, l: SOUND n + 100, .8

'PCOPY 1, 0
GOSUB 22500

20740 GOTO 20500

22000 :
'''''Map Load & View Screen
'PCOPY 2, 1
IF vx2 - 3 < 1 THEN vx2 = 4
IF vy2 - 3 < 1 THEN vy2 = 4
IF vx2 + 3 > wx THEN vx2 = wx - 4
IF vy2 + 3 > wy THEN vy2 = wy - 4
xleft = -3: 'IF vx2 + xleft < 0 THEN xleft = vx2 - 0
xright = 3: 'IF vx2 + xright > wx THEN xright = vx2 - wx
yleft = -3: 'IF vy2 + yleft < 0 THEN yleft = vy2 - 0
yright = 3: 'IF vy2 + yright > yx THEN yright = vy2 - wy
FOR y = -3 TO 3
  FOR x = -3 TO 3
    gr(x, y) = 0
    cr(x, y) = 0
  NEXT x
NEXT y
''''LINE (0 + 8, 0 + 8)-(5 * sz - 1 + 8, 5 * sz - 1 + 8), 0, BF
FOR y = yleft TO yright
  FOR x = xleft TO xright
   
    t = x + 4
    tt = y + 4
   
    rr$ = SPACE$(1)
    GET #1, (vx2 + x + (vy2 + y) * wx + 4), rr$
    z = ASC(rr$)
    gr(x, y) = z
    graphicput vm$(z), (t - 1) * sz, (tt - 1) * sz, "pset"
  
    chrb$ = SPACE$(1)
    GET #3, (vx2 + x + (vy2 + y) * wx + 4), chrb$
    chrb = ASC(chrb$)
    cs(x, y) = chrb
    IF cs(x, y) > 0 THEN
     graphicput LEFT$(obj$(chrb, gc), 4) + "-" + RIGHT$(obj$(chrb, gc), 7), (t - 1) * sz + INT((sz - obj(chrb)) / 2), (tt - 1) * sz + INT((sz - obj(chrb)) / 2), "and"
     graphicput obj$(chrb, gc), (t - 1) * sz + INT((sz - obj(chrb)) / 2), (tt - 1) * sz + INT((sz - obj(chrb)) / 2), "or"
    END IF

    chrb$ = SPACE$(1)
    GET #2, (vx2 + x + (vy2 + y) * wx + 4), chrb$
    chrb = ASC(chrb$)
    cr(x, y) = chrb
    IF cr(x, y) > 0 THEN
     graphicput LEFT$(obj$(chrb, gc), 4) + "-" + RIGHT$(obj$(chrb, gc), 7), (t - 1) * sz + INT((sz - obj(chrb)) / 2), (tt - 1) * sz + INT((sz - obj(chrb)) / 2), "and"
     graphicput obj$(chrb, gc), (t - 1) * sz + INT((sz - obj(chrb)) / 2), (tt - 1) * sz + INT((sz - obj(chrb)) / 2), "or"
    END IF
  
    'PSET ((320 - wx / 2) + vx2 + x, (175 - wy / 2) + vy2 + y), vm(z)
  NEXT x
NEXT y
'PCOPY 1, 2
'PSET ((320 - wx / 2) - 1, (175 - wy / 2) - 1), 11
'LINE -((320 - wx / 2) + wx + 1, (175 - wy / 2) + wy + 1), 11, B
'PSET ((320 - wx / 2) + vx2 + xleft, (175 - wy / 2) + vy2 + yleft), 8
'LINE -((320 - wx / 2) + vx2 + xright, (175 - wy / 2) + vy2 + yright), 8, B
RETURN

22500 :
FOR y = yleft TO yright
  FOR x = xleft TO xright
    rr$ = SPACE$(1)
    GET #1, (vx2 + x + (vy2 + y) * wx + 4), rr$
    z = ASC(rr$)
    gr(x, y) = z
    't = x + 3
    'tt = y + 3
    'graphicput vm$(z), (t + 0 - 1) * sz + 8, (tt + 0 - 1) * sz + 8
    'PSET ((320 - wx / 2) + vx2 + x, (175 - wy / 2) + vy2 + y), vm(z)
  NEXT x
NEXT y
'PSET ((320 - wx / 2) - 1, (175 - wy / 2) - 1), 11
'LINE -((320 - wx / 2) + wx + 1, (175 - wy / 2) + wy + 1), 11, B
RETURN

23000 :
'''''Map View
'PCOPY 2, 1
'PSET ((320 - wx / 2) - 1, (175 - wy / 2) - 1), 11
'LINE -((320 - wx / 2) + wx + 1, (175 - wy / 2) + wy + 1), 11, B

IF 1 = 0 THEN

FOR y = 0 TO wy
  FOR x = 0 TO wx
   
    REM' the following blocked if blanks the object map
    IF 1 = 1 THEN
     rr$ = CHR$(0)
     PUT #2, (x + y * wx + 4), rr$
    END IF
   
    REM' the following blocked if blanks the low object map
    IF 1 = 1 THEN
     rr$ = CHR$(0)
     PUT #3, (x + y * wx + 4), rr$
    END IF

    rr$ = SPACE$(1)
    GET #1, (x + y * wx + 4), rr$
    z = ASC(rr$)
    PSET ((320 - wx / 2) + x, (175 - wy / 2) + y), vm(z)
  NEXT x
  'PCOPY 1, 0
NEXT y
'PCOPY 1, 2
'WHILE INKEY$ = "": WEND
'PSET ((320 - wx / 2) - 1, (175 - wy / 2) - 1), 11
'LINE -((320 - wx / 2) + wx + 1, (175 - wy / 2) + wy + 1), 11, B

END IF

CLS
'PCOPY 1, 0

IF 1 = 0 THEN
 FOR y = 0 TO wy
  FOR x = 0 TO wx
   rr$ = CHR$(0)
   PUT #2, (x + y * wx + 4), rr$
   rr$ = CHR$(0)
   PUT #3, (x + y * wx + 4), rr$
  NEXT x
 NEXT y
END IF

'rr$ = CHR$(1)
'PUT #2, (vx1 + vy1 * wx + 4), rr$

RETURN

23100 'VisCMND
23102 'PCOPY 1, 0
23105 ZL = 0: z = 0: z$ = "": CB = 1: IN$ = "": il = LEN(IN$)
23110 z$ = INKEY$: IF z$ <> "" THEN 23150

23115 :
COLOR 15: LOCATE , 1: PRINT IN$; : il = LEN(IN$)

23116 'IF CB=1 THEN COLOR 9
23117 'IF CB=2 THEN COLOR 12
23118 'IF CB=3 THEN COLOR 14
23120 'LOCATE ,IL+1:PRINT MID$("۲",CB,1);"  ";:COLOR 15
23121 'LOCATE ,IL+1:PRINT MID$("",CB,1);"  ";:COLOR 15
23122 PB = PEN(3): px = PEN(4): py = PEN(5)
23123 'IF PB=-1 THEN X=INT(PX/8):Y=INT((PY/8)
23124 'IF pb<>-1 THEN px=(pos(0)-1)*8:py=(csrlin-1)*8)
23125 x = (POS(0) - 1) * 8: py = (CSRLIN - 1) * 8
23126 IF px > 311 THEN px = 311 ELSE IF px < 0 THEN px = 0
23127 IF py > 191 THEN py = 191 ELSE IF py < 0 THEN py = 0
23128 LOCATE , il + 1: PRINT "  "; : COLOR 15
23129 COLOR 5: LOCATE , il + 1: PRINT MID$("", CB, 1); "  "; : COLOR 15
23130 'PCOPY 1, 0
23131 IF TIMER - bt > BR THEN CB = (CB MOD 3) + 1: bt = TIMER
23140 GOTO 23110
23150 ZL = LEN(z$): z = ASC(z$)
23160 IF (z < 32 OR z > 125) AND z <> 13 AND z <> 8 AND z <> 27 THEN 23115
23170 IF (z >= 32 AND z <= 125) AND il < 70 AND il < 36 THEN IN$ = IN$ + z$: il = LEN(IN$): GOTO 23115
23180 IF z = 8 AND il > 0 THEN IN$ = LEFT$(IN$, il - 1): il = LEN(IN$): GOTO 23115
23190 IF z = 13 THEN COLOR 15: LOCATE , 1: PRINT IN$; "   "; : PRINT : RETURN
23200 IF z = 27 THEN IN$ = "": COLOR 15: LOCATE , 1: PRINT STRING$(35, CHR$(32)): PRINT : RETURN
23210 il = LEN(IN$): PCOPY 1, 0: GOTO 23115

SUB graphicput (grpt$, x, y, m$)
MID$(grpt$, 12, 1) = "v"
IF x + sz - 1 < 640 AND y + sz - 1 < 350 THEN
 'IF grpt$ = "" THEN LINE (x, y)-(x + sz - 1, y + sz - 1), 0, BF
 IF grpt$ <> "" THEN
  DEF SEG = VARSEG(scn(0))
  BLOAD grpt$, VARPTR(scn(0))
  IF m$ = "or" THEN
   PUT (x, y), scn(0), OR
  END IF
  IF m$ = "and" THEN
   PUT (x, y), scn(0), AND
  END IF
  IF m$ = "pset" THEN
   PUT (x, y), scn(0), PSET
  END IF
 END IF
END IF
'GET (0, 0)-(7, 7), scn
'DEF SEG = VARSEG(scn(0))
'BSAVE grpt$, VARPTR(scn(0)), 8 * 8 + 8
END SUB

